// myRaytracer.cpp - fsh; adjusted 1/29/2000 for ECE661,Spring 2000
// after adjusting SDL to add Ray, Intersection, etc.
// Use Scene class to draw a scene with openGL
// some pieces left to students to implement
#include "SDL.h"
#include "Camera.h"
#include <math.h>
#include <io.h>
//############################ GLOBALS ########################
Camera cam; // construct it
Scene scn;  // construct it
int screenWidth = 300, screenHeight = 300;
int doRayTrace = 0;
float lightStrength = 1.0;
float amount = 1.0;
int blockSize = 8;
string myFileName;
//<<<<<<<<<<<<<<<<<<<<<< getFileName >>>>>>>>>>>>>>>>.
void getFileName(string& fname)
{ // displays list of all .dat files in current directory - must #include <io.h>
	struct _finddata_t dat_file;
	long hFile;
	if( (hFile = _findfirst("*.dat", &dat_file)) == -1L)
		 cout << " No *.dat files in current directory!\n";
	else
	{
			cout << "Available *.dat files\n";
			cout << "FILE NAME\t\tSIZE\n";
			cout << dat_file.name << "\t\t"<< dat_file.size << endl;
			while( _findnext( hFile, &dat_file) == 0)
					cout << dat_file.name <<"\t\t";
	}
	_findclose(hFile);
	cout << "type file name: (omit the '.dat') \n";
	cin >> fname;
	fname += ".dat";
}

//<<<<<<<<<<<<<<<<<<<<<<<< myKeyboard >>>>>>>>>>>>>>>>>>>>>>
void myKeyboard(unsigned char key, int x, int y)
{
	string fname;
	Light * p = NULL;
	float vAngle, aspect, nrDist, frDist;
	double inc = 0.25;
	float fovy,asp,nr,fr;
	cam.getShape(fovy,asp,nr,fr);
	fovy *= 3.14159265f/180.0f; //degrees to radians
	float top = nr * sin(fovy)/cos(fovy);
	float right = top * asp;
	float winWid = 2 * right;
	float winHt =  2 * top;
	//GeomObj* pt = NULL;

	static int numGot = 0;
	static string s = "";
	if(key == 27) exit(-1);
	if(key == '.'|| key == ' '){numGot = 0; return;}
	if(numGot % 2 == 0)	{s = ""; numGot = 0;}
	s += key;
	numGot++;
	if(numGot == 1) return; // need another char for command
	//now have two letter command; process it
	//###############################################
	if(s == "LS"){
		lightStrength += 0.1f; 
		for(p = scn.light; p; p = p -> next)
		{//make each color a brighter white
			p->color.red = p->color.green = p->color.blue =lightStrength ;
		}
		cout << "light strength = " << lightStrength << endl;
	}
	else if(s == "ls")
	{
		lightStrength -= 0.1f;
		for(p = scn.light; p; p = p-> next)
		{//make each color a dimmer white
			p->color.red = p->color.green = p->color.blue =lightStrength;
		}
		cout << "light strength = " << lightStrength << endl;
	}
	else if(s == "qu") exit(-1); 
	else if(s == "AM") amount *= 2;
	else if(s == "am") amount /= 2;
	else if(s == "sf") cam.slide(0,0, -amount);  // slide camera forward
	else if(s == "sb") cam.slide(0,0,amount);  //slide camera back	
	else if(s == "sl") cam.slide(-amount,0,0);  // slide camera to left
	else if(s == "sr") cam.slide(amount, 0,0);  //slide camera right
	else if(s == "su") cam.slide(0,amount, 0);  //slide camera up
	else if(s == "sd") cam.slide(0,-amount,0);  //slide camera down
	else if(s == "pu") cam.pitch(-10 * amount); 
	else if(s == "pd") cam.pitch( 10 * amount); 
	else if(s == "rl") cam.roll( 10 * amount);  //roll CCW
	else if(s == "rr") cam.roll(-10 * amount);  //roll CW
	else if(s == "yl") cam.yaw( -10 * amount); 
	else if(s == "yr") cam.yaw(10 * amount); 
	else if(s == "c1") cam.set(10.0,10.0,10.0,0,0,0,0,1,0);
  	else if(s == "c2") cam.set(0,0,10,0,0,0,0,1,0); 
	else if(s == "c3") cam.set(10,0,0,0,0,0,0,1,0); 
	else if(s == "c4") cam.set(1,10,0,0,0,0,0,1,0);
	else if(s == "c5") cam.set(2,4,2,0,0,0,0,1,0);
	else if(s == "c6") cam.set(0,6,6,0,1,0,0,1,0);
	else if(s == "c7") cam.set(1.3,0.82,3,0,0.2,0,0,1,0);
	else if(s == "c8") cam.set(1.68,0.72,2.25,0,0.2,0,0,1,0);
	else if(s == "c9") cam.set(1.4,1.1,2,0,0.1,0,0,1,0);
	else if(s == "CV")//open camera 
	{
		cam.getShape(vAngle, aspect, nrDist, frDist); vAngle += 5.0;
		cam.setShape(vAngle, aspect, nrDist, frDist);
	}
	else if(s == "cv") //close camera
	{
		cam.getShape(vAngle, aspect, nrDist, frDist); vAngle -= 5.0; 
		cam.setShape(vAngle, aspect, nrDist, frDist); 
	}
	else if(s == "r8"){ blockSize = 8; doRayTrace = 1;} 
	else if(s == "r1"){ blockSize = 1; doRayTrace = 1;} 
	else if(s == "r4"){ blockSize = 4; doRayTrace = 1;}
	else if(s == "r2"){ blockSize = 2; doRayTrace = 1;} 
	else if(s == "r0") {blockSize = 16;doRayTrace = 1;}
	else if(s == "rs")// read scene file
	{
		getFileName(fname); myFileName = fname; scn.read(fname);
	}
	else cout << "\nnot a valid command\n";
	glutPostRedisplay();
}
//<<<<<<<<<<<<<<<<<<<<<<<<<< myReshape >>>>>>>>>>>>>>>>>>>
void myReshape(int width, int height)
{ // adjust the camera aspect ratio to match that of the viewport
	float vAngle, aspect, nrDist, frDist;
	screenWidth = width; // update screen dimensions
	screenHeight = height;
	cam.setDisplay(height,width);
	cam.getShape(vAngle, aspect, nrDist, frDist);// get vAngle,nrDist,frDist
	aspect = (float)screenWidth/screenHeight; 
	cam.setShape(vAngle, aspect, nrDist, frDist); // update camera def.
	glViewport(0, 0, screenWidth, screenHeight); // update viewport
}
//<<<<<<<<<<<<<<<<<<<<<<< display >>>>>>>>>>>>>>>>>>>>>>>>>>
void display(void)
{
	glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);	// clear screen	
	glEnable(GL_NORMALIZE);

	cam.drawOpenGL(scn);

	glColor3f(0.0f,0.0f,0.0f);			// set color of stuff 
	
	if(doRayTrace)
	{
		cam.raytrace(scn,blockSize);
		doRayTrace = 0;
	}
} // end of display
//<<<<<<<<<<<<<<<<<<<<<<<<<<< myinit >>>>>>>>>>>>>>>>>>>>>>>>>>>.
void myInit(void)
{
	string fname;
	glColor3f(0.0f,0.0f,0.0f);			// set color of stuff 
	glShadeModel(GL_SMOOTH); // or can be GL_FLAT
	glEnable(GL_NORMALIZE);
	glViewport(0, 0, screenWidth, screenHeight);
	cam.set(2.3f,1.3f,2, 0,0.25f,0, 0,1,0); // give eye, lookAt, up
	cam.setShape(20.0,screenWidth/(float)screenHeight,1.0, 10000.0); // match it to viewport
   cam.setDisplay(screenHeight, screenWidth); //sets nRows, nCols in camera
	getFileName(fname);
	scn.read(fname);
} // end of myInit

//<<<<<<<<<<<<<<<<<<<<<< main >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
void main(int argc, char **argv)
{
	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_RGB |GLUT_DEPTH);
	glutInitWindowSize(screenWidth, screenHeight);
	glutInitWindowPosition(0, 0);
	glutCreateWindow("raytrace the SDL scene");
	glutKeyboardFunc(myKeyboard);
	glutReshapeFunc(myReshape);
	glutDisplayFunc(display);
	//glutMouseFunc(myMouse);
	myInit();
	glutMainLoop();
}
